# coding: utf-8

"""
    ARTIK Cloud API

    OpenAPI spec version: 2.0.0

    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from __future__ import absolute_import

import os
import sys
import time
import unittest

import artikcloud
from artikcloud.rest import ApiException
from artikcloud.apis.messages_api import MessagesApi

class TestMessagesApi(unittest.TestCase):
    """ MessagesApi unit test stubs """

    def setUp(self):
        configuration = artikcloud.Configuration();
        configuration.access_token = "dc43d12e2b59495daf94631e6ddfe3e8"
        self.messages_api = MessagesApi()
        pass

    def tearDown(self):
        pass

    def test_get_aggregates_histogram(self):
        """
        Test case for get_aggregates_histogram

        Get Normalized Message Histogram
        """
        pass

    def test_get_field_presence(self):
        """
        Test case for get_field_presence

        Get normalized message presence
        """
        pass

    def test_get_last_normalized_messages(self):
        """
        Test case for get_last_normalized_messages

        Get Last Normalized Message
        """
        pass

    def test_get_message_aggregates(self):
        """
        Test case for get_message_aggregates

        Get Normalized Message Aggregates
        """
        pass

    def test_get_message_snapshots(self):
        """
        Test case for get_message_snapshots

        Get Message Snapshots
        """
        pass

    def test_get_normalized_actions(self):
        """
        Test case for get_normalized_actions

        Get Normalized Actions
        """
        pass

    def test_get_normalized_messages(self):
        """
        Test case for get_normalized_messages

        Get Normalized Messages
        """
        pass

    def test_send_actions(self):
        """
        Test case for send_actions

        Send Actions
        """
        pass

    def test_send_message(self):
        """
        Test case for send_message

        Send Message
        """
        message = artikcloud.Message()
        message.type = "message"
        message.sdid = "19da42ee01414722a6ad1224097c38d4"
        message.ts = int(round(time.time() * 1000))
        message.data = {'steps': 5}

        response = self.messages_api.send_message(message)
        self.assertIsNotNone(response)
        messageid = response.data.mid
        self.assertIsNotNone(messageid)

        # get normalized message from mid
        time.sleep(1)
        envelope = self.messages_api.get_normalized_messages(mid=messageid)
        self.assertIsNotNone(envelope)
        self.assertEqual(envelope.size, 1)

        normalized = envelope.data[0]
        self.assertIsNotNone(normalized)
        self.assertEqual(normalized.mid, messageid)

        steps = normalized.data['steps']
        self.assertIsNotNone(steps)
        self.assertEqual(steps, 5.0)
        pass


if __name__ == '__main__':
    unittest.main()
